
<template>
  <q-page class="flex">
    <div class="doc-container col-12">
      <div class="minheight-rows gutter-xs">
        <div class="row title-row items-center">
          <i class="fas fa-th-large"></i>
          <div class="page-title">{{ $t('Categories') }}</div>
        </div>
      </div>
      <div class="row md-gutter justify-center margin-bottom-20">
          <div class="col-6">
          </div>
          <div class="col-6">
            <div class="row justify-end items-center">
              <q-btn
                icon="add"
                :label="$t('category.add')"
                @click="newCategory"
                class="action-btn"
                rounded
              />
            </div>
          </div>
        </div>
      <div class="row md-gutter justify-center margin-bottom-20">
            <div class="col-12">

                <q-table
                    :data="filteredItems"
                    :columns="columns"
                    row-key="id">
                  <template slot="top-left" slot-scope="props">
                    <div class="col">
                      <div class="row" style="margin-bottom: 10px">
                        <div class="q-table-title"><i class="fas fa-th-large"></i> {{ $t('category.search') }}</div>
                      </div>
                      <div class="row">
                        <q-search clearable v-model="searchedCategory"/>
                      </div>
                    </div>
                  </template>

                    <q-tr slot="header" slot-scope="props">
                        <q-td>{{ $t('Label') }}</q-td>
                        <q-td>{{ $t('Thumbnail') }}</q-td>
                        <q-td >{{ $t('Order') }}</q-td>
                        <q-td >{{ $t('Actions') }}</q-td>
                    </q-tr>
                    <q-tr  slot="body"
                            slot-scope="props"
                            :props="props"
                            :class="conditionalColoring(props.row.__index)">
                        <q-td key="id" :props="props" class=""> {{ categoryLabel(props.row) }} </q-td >
                        <q-td key="id" :props="props" class="">
                          <q-btn round size="xm" v-on:click="displayThumbnailInDialog(thumbUrl(props.row))" >
                            <q-avatar size="1px">
                              <img
                              :src="thumbUrl(props.row)"
                              style="height: 45px; max-width: 46px"
                              clickable >
                            </q-avatar>
                          </q-btn>
                        </q-td >
                        <q-td key="id" :props="props" class="">
                          <div class="row justify-center no-wrap">
                            <q-btn-group rounded v-if="props.row.__index !== 0 && !isLast(props.row)">
                              <q-btn size="sm"
                              dense rounded
                              color="secondary"
                              icon="arrow_upward"
                              v-on:click="moveUp(props.row.__index)"
                              />
                              <q-btn size="sm"
                              dense rounded
                              color="secondary"
                              icon="arrow_downward"
                              v-on:click="moveDown(props.row.__index)"
                              />
                            </q-btn-group>
                            <q-btn-group rounded v-if="props.row.__index === 0 && countList(props.row.length)">
                              <q-btn size="sm"
                                dense rounded
                                color="secondary"
                                class="solo-arrow"
                                icon="arrow_downward"
                                v-on:click="moveDown(props.row.__index)"
                              />
                            </q-btn-group>
                            <q-btn-group rounded v-if="isLast(props.row)">
                              <q-btn size="sm"
                                dense rounded
                                color="secondary"
                                class="solo-arrow"
                                icon="arrow_upward"
                                v-on:click="moveUp(props.row.__index)"
                              />
                            </q-btn-group>
                          </div>
                        </q-td >
                        <q-td key="id" :props="props" class="">
                          <q-btn
                            :title="$t('Edite_category')"
                            class="spacing"
                            size="sm"
                            round
                            color="teal"
                            icon="edit"
                            @click.native="editCategory(props.row.__index)"
                          />
                          <q-btn
                            :title="$t('Upload_thumbnail')"
                            class="spacing"
                            size="sm"
                            round
                            color="orange"
                            icon="image"
                            @click.native="uploadThumbnail(props.row.__index)"
                          />
                          <q-btn
                            :title="$t('Delete_category')"
                            class="spacing"
                            size="sm"
                            round
                            color="red"
                            icon="delete"
                             @click.native="delCategory(props.row.__index)"
                          />
                        </q-td >
                    </q-tr>
                </q-table>
            </div>
        </div>
    </div>
    <q-dialog v-model="uploadDialogDisplayed" :ok=false>
      <span slot="title" class="row items-center">
        <div class="text-h6">{{ $t('Upload_thumbnail') }}</div>

        <q-btn icon="close" flat round dense size="sm" @click.native="closeUpload()"/>
      </span>
      <div slot="body">
        <q-uploader :url="categoryThumbnailUrl" send-raw method="PUT"
        :upload-factory="uploadFile" max-file-size="500000" @uploaded="finishedUpload" @fail="uploadFailed"
        auto-expand/>
      </div>
    </q-dialog>
    <q-dialog v-model="imageDialogDisplayed" :ok=false>
        <div slot="body" align="self-center"  style=" width: 160px; height: 160px;" >
          <img :src="imageUrlToDialog"
          style=" position: absolute; top:0%; bottom:0%; left: 0%; right: 0%; width: 100%; height: 100%;" >
        </div>
    </q-dialog>
  </q-page>
</template>

<style>
</style>

<script>
import {mapActions, mapState} from 'vuex'
export default {
  name: 'Categories',
  data: () => ({
    searchedCategory: '',
    layoutModal: false,
    isEditing: false,
    labels: {},
    tags: [],
    name: '',
    username: '',
    password: '',
    playlists: [],
    applications: [],
    contents: [],
    selectorDisplayed: false,
    loadedCategoryIndex: null,
    uploadDialogDisplayed: false,
    imageDialogDisplayed: false,
    categoryThumbnailUrl: '',
    afterUploadCacheBreaker: '',
    imageUrlToDialog: '',
    columns: [
      {
        name: 'id',
        label: 'Id',
        required: true,
        visible: false,
        align: 'left'
      },
      {
        name: 'order',
        label: 'Order',
        required: true,
        visible: false,
        align: 'left'
      },
      {
        name: 'thumbnail',
        label: 'Thumbnail',
        required: true,
        visible: false,
        align: 'left'
      },
      {
        name: 'actions',
        label: 'Actions',
        required: true,
        visible: true,
        align: 'left'
      },
      {
        name: 'label',
        label: 'Label',
        required: true,
        visible: true,
        align: 'left'
      }
    ]
  }),
  methods: {
    ...mapActions('categories', [
      'listCategories',
      'listTerms',
      'setThumbnail',
      'deleteCategory',
      'moveCategoryUp',
      'moveCategoryDown'
    ]),
    conditionalColoring: function (index) {
      return index % 2 === 0 ? 'conditional-coloring' : ''
    },
    moveUp: function (categoryIndex) {
      this.moveCategoryUp(categoryIndex)
    },
    moveDown: function (categoryIndex) {
      this.moveCategoryDown(categoryIndex)
    },
    isLast: function (row) {
      return row.__index === (this.categories.length - 1)
    },
    displayThumbnailInDialog: function (imageUrl) {
      this.imageUrlToDialog = imageUrl
      this.imageDialogDisplayed = true
    },
    countList: function (rowLength) {
      return rowLength > 2 ? 'True' : 'False'
    },
    editCategory: function (categoryIndex) {
      console.log('index dans la page test2 fonction deletecat: ' + categoryIndex)
      console.log('id dans la page test2 fonction deletecat: ' + this.categories[categoryIndex].id)
      this.$router.push('/categories/edit/' + categoryIndex)
    },
    delCategory: function (categoryIndex) {
      this.$q.dialog({
        title: this.$t('category.Delete'),
        message: this.$t('category.delete_confirm'),
        ok: this.$t('state.Delete'),
        cancel: this.$t('Cancel')
      }).then(() => {
        this.$q.notify({
          message: this.$t('state.Deleted'),
          timeout: 3000,
          type: 'positive',
          icon: 'delete',
          detail: this.$t('category.delete_confirmation'),
          position: 'top-right'
        })
        this.deleteCategory({categoryIndex})
      })
    },
    uploadThumbnail: function (categoryIndex) {
      this.categoryThumbnailUrl = this.categories[categoryIndex].thumbnailUrl
      this.loadedCategoryIndex = categoryIndex
      this.uploadDialogDisplayed = true
    },
    newCategory: function () {
      this.$router.push('/categories/add')
    },
    categoryLabel: function (row) {
      var finalLabel = ''
      for (var c in row.labels) {
        if (finalLabel !== '') {
          finalLabel += ' - '
        }
        finalLabel += row.labels[c] + '(' + c + ')'
      }
      return finalLabel
    },
    uploadFile: function (file, updateProgress) {
      let promise = this.setThumbnail({categoryIndex: this.loadedCategoryIndex, file: file, progress: updateProgress})

      return promise
    },
    finishedUpload: function () {
      this.closeUpload()
    },
    uploadFailed: function () {
      this.$q.notify('Upload failed. Is file too big ?')
    },
    closeUpload: function () {
      this.uploadDialogDisplayed = false
    },
    thumbUrl: function (cat) {
      return cat.thumbnailUrl + '?' + this.pictureSuffix
    }
  },
  computed: {
    filteredItems: function () {
      if (!this.searchedCategory) {
        return this.categories
      }
      return this.categories.filter(category => {
        return this.categoryLabel(category).toLowerCase().includes(this.searchedCategory.toLowerCase())
      })
    },
    ...mapState('categories', {
      categories: (state) => state.categories,
      pictureSuffix: (state) => state.pictureSuffix
    })
  },
  mounted: function () {
    this.listCategories()
    this.listTerms()
    // this.listInstalledApps()
    // this.listPlaylists()
  }
}
</script>

<style>
.rounded-img-border{
  border-radius: 10px;
  width: 10px;
  height: auto;
}

.conditional-coloring{
  background-color: rgba(236, 243, 243, 0.219);
}

.spacing{
  margin: 2%;
}
</style>
